<?php
/*****************************************************************************
FozzyMail : Web based mail client created by Matthieu Fron
Copyright (C) 2003  Matthieu Fron

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

web site : http://fozzymail.mferon.com
web contact : fozzymail@mferon.com
******************************************************************************/
define("FOZZY_CONF",1);
define("FOZZY_ALL",2);
class FozzyMail_config
{
	var $ud;
	var $mboxes;
	var $messgs;
	var $nonlu;
	var $bg_col;
	var $fg_col;
	var $affimg;
	var $keepsent;
	var $mailboxes;
	var $mails;
	var $totsize;
	var $tri;
	var $supp;
	var $nopopup;
	var $valert;
	
	function FozzyMail_config($udir, $load_type=FOZZY_ALL)
	{
		$this->mboxes=0;
		$this->messgs=0;
		$this->nonlu=0;
		$this->bg_col="E09B4D";
		$this->fg_col="F5D598";
		$this->affimg=false;
		$this->keepsent=false;
		$this->mailboxes=null;
		$this->mails=null;
		$this->ud = $udir;
		$this->totsize=0;
		$this->tri = Array( "mode" => "date", "sens" => "desc" );
		$this->supp = false;
		$this->nopopup = false;
		$this->valert = true;
		if ( $this->ud != "" )
		{
			if ( ($fp=@fopen($this->ud."inbox.php","r")) != false )
			{
				while( !feof($fp) )
				{
					$txt = fgets($fp);
					if ( ereg("^\[CONFIG\]",$txt) )
					{
						$load=1;
					}
					else if ( ereg("^\[MAILBOXES\]",$txt) )
					{
						if ( $load_type == FOZZY_CONF ) break;
						$load=2;
					}
					else if ( $load==1 )
					{
						if ( ereg("^bg_color=([^\r\n]*)",$txt,$regs) ) $this->bg_col = $regs[1];
						else if ( ereg("^fg_color=([^\r\n]*)",$txt,$regs) ) $this->fg_col = $regs[1];
						else if ( ereg("^affimg=([^\r\n]*)",$txt,$regs) ) 
						{
							if ( $regs[1] == 1 ) $this->affimg = true;
						}
						else if ( ereg("^keepsent=([^\r\n]*)",$txt,$regs) ) 
						{
							if ( $regs[1] == 1 ) $this->keepsent = true;
						}
						else if ( ereg("^supp=([^\r\n]*)",$txt,$regs) ) 
						{
							if ( $regs[1] == 1 ) $this->supp = true;
						}
						else if ( ereg("^nopopup=([^\r\n]*)",$txt,$regs) ) 
						{
							if ( $regs[1] == 1 ) $this->nopopup = true;
						}
						else if ( ereg("^sign=([^\r\n]*)",$txt,$regs) ) 
						{
							if ( $regs[1] == 1 ) $this->sign = true;
						}
						else if ( ereg("^valert=([^\r\n]*)",$txt,$regs) ) 
						{
							if ( $regs[1] != 1 ) $this->valert = false;
						}
						else if ( ereg("^tri_field=([^\r\n]*)",$txt,$regs) ) 
						{
							$this->tri["mode"] = $regs[1];
						}
						else if ( ereg("^tri_ord=([^\r\n]*)",$txt,$regs) ) 
						{
							$this->tri["sens"] = $regs[1];
						}
					}
					else if ( $load==2 )
					{
						if ( !ereg("\?>", $txt ) )
						{
							if ( ereg("^id=",$txt) )
							{
								if ( is_array($ml) ) 
								{
									$ml["size"]=0;
									$this->mailboxes[]=$ml;
								}
								$ml="";
							}
							ereg("([a-z]*)=([^\r\n]*)",$txt,$regs);
							$ml[$regs[1]]=$regs[2];
						}
					}
				}
				if ( $load_type == FOZZY_ALL ) 
				{
					$ml["size"]=0;
					$this->mailboxes[]=$ml;
				}
				if ( is_array( $this->mailboxes ) ) $this->mboxes=count($this->mailboxes);
				fclose($fp);
			}
		}
	}
	function fozzy_fetch_mails( $marqs )
	{
		$ret=true;
		for ( $i=0; $i<$this->mboxes; $i++ )
		{
			if ( $this->mailboxes[$i]["activ"] != 1 )
			{
				if ( ($fs = get_connection($this->mailboxes[$i]["pop"],$this->mailboxes[$i]["pport"],$this->mailboxes[$i]["box"],$this->mailboxes[$i]["pass"]))!=false)
				{
					$start=$this->messgs;	
					$seens = new FozzySeens($this->ud);
					fputs($fs,"LIST \r\n");
					if ( substr(fgets($fs),0,3) == "+OK" )
					{
						while(($rep = fgets($fs))!=".\r\n")
						{
							$this->mails[]=new FozzyMail_mail($rep,$this->ud);
							$this->messgs++;
						}
					}
					if ( $this->messgs>0 )
					{
						for( $j=$start; $j<$this->messgs ; $j++ )
						{
							$this->totsize += $this->mails[$j]->size;
							$this->mailboxes[$i]["size"] += $this->mails[$j]->size;
							$this->mails[$j]->boxid = $this->mailboxes[$i]["id"];
							$this->mails[$j]->load_descrmess($fs);
							$this->mails[$j]->messid = $this->mailboxes[$i]["id"]."_".$this->get_messid($this->mails[$j]);
							if ( ereg("-".quotemeta($this->mails[$j]->messid)."-",$marqs ) )
							{
								if ( substr($marqs,0,1) == "S" )
								{
									$this->mails[$j]->seen = true;
									$seens->flag_seenfile( $this->mails[$j]->messid );
								}
								else if ( substr($marqs,0,1) == "U" )
								{
									$this->mails[$j]->seen = false;
									$seens->unflag_seenfile( $this->mails[$j]->messid );
								}
							}
							else
							{
								if ( $seens->search($this->mails[$j]->messid) >= 0 )
								{
									$this->mails[$j]->seen = true;
								}
							}
						}
						$seens->clean_seenfile($this->mailboxes[$i]["id"]);
					}
					$this->nonlu = $this->messgs - $seens->seenb;
					$seens->save_seenfile();
					unset($seens);
					close_connection($fs);
				}
				else
				{
					$ret=false;
					break;
				}
			}
		}
		return($ret);
	}
	function fozzy_fetch_emls($subpath)
	{
		$ret=true;
		$fd = dir($this->ud.$subpath."/");
		while($file = $fd->read())
		{
	    	if ( ereg("FOZZYMAIL_.*\.eml",$file) )
	    	{
				if (($fs = fopen( $this->ud.$subpath."/".$file,"r"))!=false)
				{
					$sent=new FozzyMail_mail("0 ".filesize($this->ud.$subpath."/".$file),$this->ud);
					if ( ($ret = $sent->load_header($fs,$sent->hd)) != false )
					{
						if ( eregi("multipart/mixed",$sent->hd["content-type"])) $sent->attach = true;
					}
					$this->totsize += $sent->size;
					$sent->hd["Date"] = filemtime($this->ud.$subpath."/".$file);
					$sent->messid = $file;
					$this->mails[] = $sent;
					$this->messgs++;
					fclose($fs);
				}
			}
		}
		$fd->close();
	}
	function fozzy_fetch_a_eml( $subpath )
	{
		if (($fs = fopen( $this->ud.$subpath,"r"))!=false)
		{
			$sent=new FozzyMail_mail("0 ".filesize($this->ud.$subpath),$this->ud);
			if ( ($ret = $sent->load_message($fs)) != false )
			{
				if ( $this->attanb > 0 ) $this->attach=true;
			}
			$sent->hd["Date"] = filemtime($this->ud.$subpath);
			fclose($fs);
		}
		return( $sent );
	}
	function fozzy_fetch_eml_header( $subpath )
	{
		if (($fs = fopen( $this->ud.$subpath,"r"))!=false)
		{
			$ret="";
			while( !feof($fs) )
			{
				$tmp = fgets($fs);
				if ( $tmp == "\r\n" ) break;
				$ret .= $tmp;
			}
			fclose($fs);
		}
		return( $ret );
	}
	function fozzy_fetch_eml_source( $subpath )
	{
		if (($fs = fopen( $this->ud.$subpath,"r"))!=false)
		{
			$ret="";
			while( !feof($fs) )
			{
				echo nl2br(htmlentities(fgets($fs)));
			}
			fclose($fs);
		}
		return( $ret );
	}
	function fozzy_create_eml( $bx, $ms, $rep )
	{
		if ( ($fs = get_connection($this->mailboxes[$bx]["pop"],$this->mailboxes[$bx]["pport"],$this->mailboxes[$bx]["box"],$this->mailboxes[$bx]["pass"]))!=false)
		{
			fputs($fs,"RETR ".$ms." \r\n");
			if (substr(($ret = fgets($fs)),0,3) == "+OK" )
			{
				if ( $rep == "tmp" )
				{
					do
					{
						$ret = fgets($fs);
						echo $ret;
					}
					while($ret!=".\r\n");
				}
				else
				{
					$fname = "FOZZYMAIL_".md5(uniqid(time())).".eml";
					if ( ($fp = fopen($this->ud.$rep."/".$fname,"w")) != false )
					{
						do
						{
							$ret = fgets($fs);
							fwrite($fp,$ret);
						}
						while($ret!=".\r\n");
						fclose($fp);
					}
					else
						$fname="";
				}
			}
			close_connection($fs);
		}
		return( $fname );
	}
	function get_messid($mail)
	{
		if ( $mail->hd["message-id"] != "" )
		{
			$ret = str_replace("\r\n","",$mail->hd["message-id"]);
		}
		else
		{
			$ret = str_replace("\r\n","",$mail->hd["to"].$mail->hd["subject"].recu($mail->hd["received"]).$mail->hd["date"]);
		}
		return($ret);
	}
	function fozzy_fetch_a_mail( $bx, $ms )
	{
		$seens = new FozzySeens($this->ud);
		$mail = new FozzyMail_mail("$ms 0",$this->ud);
		$mail->boxid=$bx;
		if ( ($fs = get_connection($this->mailboxes[$bx]["pop"],$this->mailboxes[$bx]["pport"],$this->mailboxes[$bx]["box"],$this->mailboxes[$bx]["pass"]))!=false)
		{
			$mail->load_fullmess($fs);
			close_connection($fs);
		}
		$mail->messid = $this->mailboxes[$bx]["id"]."_".$this->get_messid($mail);
		$seens->flag_seenfile($mail->messid);
		$seens->save_seenfile();
		unset($seens);
		return( $mail );
	}
	function fozzy_fetch_mail_header( $bx, $ms )
	{
		$ret="";
		if ( ($fs = get_connection($this->mailboxes[$bx]["pop"],$this->mailboxes[$bx]["pport"],$this->mailboxes[$bx]["box"],$this->mailboxes[$bx]["pass"]))!=false)
		{
			fputs($fs,"TOP ".$ms." 1\r\n");
			if (substr(($rep = fgets($fs)),0,3) == "+OK" )
			{
				$secur=0;
				while( (($rep = fgets($fs) ) != "\r\n" ) && ( $secur != 1000 ))
				{
					$secur++;
					if ( $rep === false ) break;
					$ret .= $rep;
				}
			}
			close_connection($fs);
		}
		return( $ret );
	}
	function fozzy_fetch_mail_source( $bx, $ms )
	{
		$ret="";
		if ( ($fs = get_connection($this->mailboxes[$bx]["pop"],$this->mailboxes[$bx]["pport"],$this->mailboxes[$bx]["box"],$this->mailboxes[$bx]["pass"]))!=false)
		{
			fputs($fs,"RETR ".$ms."\r\n");
			if (substr(($rep = fgets($fs)),0,3) == "+OK" )
			{
				while( ($rep = fgets($fs) ) != ".\r\n" )
				{
					echo nl2br(htmlentities($rep));
				}
			}
			close_connection($fs);
		}
		return( $ret );
	}
	function fozzy_delete( $lst )
	{
		for ( $i=0; $i<$this->mboxes; $i++ )
		{
			if ( preg_match_all("/-([0-9]*)_".$i."-/",$lst,$regs) )
			{
				if ( $this->supp )
				{
					foreach($regs[1] as $val)
					{
						$this->fozzy_create_eml( $i, $val, "supp" );
					}
					reset($regs[1]);
				}
				if ( ($fs = get_connection($this->mailboxes[$i]["pop"],$this->mailboxes[$i]["pport"],$this->mailboxes[$i]["box"],$this->mailboxes[$i]["pass"]))!=false)
				{
					foreach($regs[1] as $val)
					{
						fputs($fs,"DELE ".$val."\r\n");
						if (substr(($rep = fgets($fs)),0,3) != "+OK" ) break;
					}
					close_connection($fs);
				}
			}
		}
	}
}
?>