<?php
/*****************************************************************************
FozzyMail : Web based mail client created by Matthieu Fron
Copyright (C) 2003  Matthieu Fron

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

web site : http://fozzymail.mferon.com
web contact : fozzymail@mferon.com
******************************************************************************/
function tri_adr($a,$b)
{
	$ati = $a["nom"];
	$bti = $b["nom"];
	
	return(strcmp( $ati, $bti ));
}

class FozzyMail_contacts
{
	var $nb;
	var $udir;
	var $liste;
	var $match;
	var $version;
	
	function FozzyMail_contacts($ud)
	{
		$this->nb=0;
		$this->match=-1;
		$this->udir = $ud;
		$this->liste=Array();
		$this->version="";
		if ( ($fp=@fopen($ud."contacts.php","r")) != false )
		{
			if ( !feof($fp) )
			{
				$rep = fgets($fp,1024);
				if ( ereg("^\[FZ_VERSION_V([0-9]\.[0-9]{2})\]",$rep,$regs ) )
				{
					while ( !feof($fp) )
					{
						$rep = fgets($fp,1024);
						$regs="";
						if ( ereg("^\[CONTACT\]",$rep) )
						{
							if ( is_array($ct) )
							{
								$this->liste[] = $ct;
								$this->nb++;
								$ct=null;
							}
						}
						else if ( ereg("^([^=]*)=([^\r\n]*)",$rep,$regs) )
						{
							$ct[$regs[1]] = str_replace("FZ_BR","\r\n",$regs[2]);
						}
					}
					if ( is_array($ct) )
					{
						$this->liste[] = $ct;
						$this->nb++;
						$ct=null;
					}
				}
				if ( ereg("^\[FZ_VERSION_V\]",$rep,$regs ) )
				{ // bug version 1.11
					while ( !feof($fp) )
					{
						$rep = fgets($fp,1024);
						$regs="";
						if ( ereg("^\[CONTACT\]",$rep) )
						{
							if ( is_array($ct) )
							{
								$this->liste[] = $ct;
								$this->nb++;
								$ct=null;
							}
						}
						else if ( ereg("^([^=]*)=([^\r\n]*)",$rep,$regs) )
						{
							$ct[$regs[1]] = str_replace("FZ_BR","\r\n",$regs[2]);
						}
					}
					if ( is_array($ct) )
					{
						$this->liste[] = $ct;
						$this->nb++;
						$ct=null;
					}
				}
				else
				{
					while ( !feof($fp) )
					{
						$rep = fgets($fp,1024);
						$regs="";
						if ( ereg("^([^ ]*)[ ]{1}([^\r\n]*)",$rep,$regs) )
						{
							$this->liste[] = Array( "nom" => $regs[2], "adr" => $regs[1] );
							$this->nb++;
						}
					}
				}
			}
			fclose($fp);
		}
		$this->version = "1.11";
	}
	function save_contacts()
	{
		if ( ($fp=fopen($this->udir."contacts.php","w")) == false )
		{
			echo "Erreur de cration/ouverture du fichier contact";
		}
		else
		{
			fwrite($fp,"[FZ_VERSION_V".$this->version."]\r\n");
			usort( $this->liste, "tri_adr" );
			for ( $i=0 ; $i<$this->nb ; $i++ )
			{
				fwrite($fp,"[CONTACT]\r\n");
				while( list($key,$val) = each($this->liste[$i]) )
				{
					if ( trim($val) != "" )
					{
						fwrite( $fp, $key."=".str_replace("\r\n","FZ_BR",$val)."\r\n" );
					}
				}
			}
			fclose($fp);
		}
	}
	function del_allcontacts()
	{
		fclose(fopen($this->udir."contacts.php","w"));
		$this->liste=null;
		$this->liste=Array();
		$this->nb=0;
	}
	function search($adr)
	{
		$ret = false;
		$this->match=-1;
		for ( $i=0 ; $i<$this->nb ; $i++ )
		{
			if ( $this->liste[$i]["adr"] == $adr )
			{
				$ret = true;
				$this->match = $i;
				break;
			}
		}
		return( $ret );
	}
	function maj_contact($oa,$a,$lst)
	{
		while( list($key,$val) = each($this->liste[$this->match]) )
		{
			$this->liste[$this->match][$key]="";
		}
		reset($lst);
		while( list($key,$val) = each($lst) )
		{
			if (( $key != "oldadr" ) && ( $key != "save" ))
			{
				$this->liste[$this->match][$key] = (stripslashes(trim($val)));
			}
		}
		$this->match=-1;
	}
	function set_contact($a,$lst)
	{
		while( list($key,$val) = each($lst) )
		{
			if (( $key != "oldadr" ) && ( $key != "save" ))
			{
				$cb[$key] = (stripslashes(trim($val)));
			}
		}
		$this->liste[]=$cb;
		$this->nb++;
		$this->match=-1;
	}
	function get_contact($a)
	{
		$ret=false;
		if ( $this->search($a) )
		{
			$ret = $this->liste[$this->match];
		}
		$this->match=-1;
		return($ret);
	}
	function get_contact_str($liste)
	{
		$ret="";
		$tb=preg_split("/;/",stripslashes($liste));
		if ( is_array($tb) )
		{
			foreach($tb as $d)
			{
				$this->match=-1;
				if ( ereg("[a-z]+",$d) )
				{
					if ( $ret != "" ) $ret .= ",\r\n\t";
					for ( $i=0 ; $i<$this->nb ; $i++ )
					{
						echo $this->liste[$i]["nom"]."\r\n";
						if ( strtolower(str_replace(" ","",$this->liste[$i]["nom"])) == strtolower(str_replace(" ","",$d)) )
						{
							$this->match = $i;
							break;
						}
					}
					if ( $this->match==-1 )
						$chn = "<".str_replace(" ","",$d).">";
					else
						$chn = "\"" . $this->liste[$this->match]["nom"] . "\" <" . $this->liste[$this->match]["adr"] . ">";
					$ret .= $chn;
				}
			}
		}
		return($ret);
	}
}
?>